"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const commander_1 = __importDefault(require("commander"));
const fs_extra_1 = require("fs-extra");
const path_1 = require("path");
commander_1.default.version("0.0.1").name("cookiecord-generator");
commander_1.default
    .command("generate <name>")
    .description("generate a new cookiecord bot")
    .action((name) => __awaiter(void 0, void 0, void 0, function* () {
    const genPath = path_1.resolve(__dirname, "../../gen");
    const selfPkgJson = yield fs_extra_1.readJSON(path_1.resolve(__dirname, "../../package.json"));
    const targetPath = path_1.join(process.cwd(), name);
    try {
        if ((yield fs_extra_1.pathExists(targetPath)) &&
            (yield fs_extra_1.readdir(targetPath)).length !== 0)
            throw new Error("Target directory exists and is not empty");
    }
    catch (error) {
        console.error(error.message);
        process.exit(1);
    }
    yield fs_extra_1.copy(genPath, targetPath);
    const pkgjson = yield fs_extra_1.readJSON(path_1.join(genPath, "package.json"));
    pkgjson.name = name;
    pkgjson.dependencies.cookiecord = `^${selfPkgJson.version.split("-")[0]}`;
    yield fs_extra_1.writeFile(path_1.join(process.cwd(), name, "package.json"), JSON.stringify(pkgjson, null, 4));
    child_process_1.spawnSync("yarn", { cwd: targetPath, stdio: "inherit" });
    console.log(`Generated at ${path_1.join(process.cwd(), name)}\nPlease run 'yarn start' to start your new bot after filling out the .env file!`);
}));
if (process.argv.length < 3)
    commander_1.default.help();
commander_1.default.parse(process.argv);
